
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>


#include "z80.h"
#include <allegro.h>


#define XLEN 256
#define YLEN 256

/*
   v 0.5 - Thanks to Bart Trzynadlowski again [I borrowed some code from Genital :)]
Laser now uses the standard Laser gamename -option command line.

   v 0.4 - Beginning of Multi Game Support - Although not true MultiGame
Now supports Space Invaders and its clones Super Earth Invasion, and 
Space Invaders (Taito) - Removed the sound code because it was too buggy 

   v 0.3 - Beginning of Sound Support - Crude, not very accurate, and 
not complete

   v 0.2a - Fixed a bug where the joystick button stayed down, preventing 
keyboard usage.

   v 0.2 - Code Optimization Thanks to Bart Trzynadlowski -

1/31/2000:  Bart e-mailed me about a more efficient way to display the 
sprites; which led to a smaller file size, and a speed increase?

   v 0.1 - Heavily Based On SinVader by Mike Green - 

1/30/2000:  This is a basis for a multi-arcade emulator project:
I am a beginning programmer - and I liked the simplicity of this emulator.
I have added code - and will be changing it to suit my needs as the time 
passes.  I might even rewrite it as I become more experienced - we'll see :)

*/


void Nmi(void);

void Nmi()
{
	IFlag=1;
}
END_OF_FUNCTION(Nmi);

void ShowHelp()
{
        printf("Laser 0.5.  Based on SinVader by Mike Green\n");
        printf("Usage:     laser gamename [options]\n");
        printf("Options:   -?,-h        Show this help text\n");
        exit(0);
}

int FindOption(char *option, int p, int h, int u, int argc, char **argv)
{
        static int      t[] = { 0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0 };
        int             i;
        char            *c;
      
        if (argc > 128)
                argc = 128;     /* maximum this function can handle is 128 */

        /*
         * if p = 1 and h = 0 will find option and return decimal value of
         * argv[i+1], if h = 1 will read it as hex.
         * if p = 0 then it will return index of option in argv[], 0 not found
         * if u = 1 will return index of first occurance of untouched option
         */

        if (u)  /* find first untouched element */
        {
                for (i = 1; i < argc; i++)
                {
                        if (!t[i])      /* 0 indicates untouched */
                                return i;
                }
                return 0;
        }

        if (p)  /* find option and return integer value following it */
        {
                for (i = 1; i < argc; i++)
                {                
                        if (strcmp(argv[i], option) == 0)       /* found */
                        {
                                if (i >= argc)                  /* bounds! */
                                        return 0;
                                t[i + 1] = t[i] = 1;            /* touched */
                                if (!h)
                                        return atoi(argv[i + 1]);
                                else
                                        return strtoul(argv[i + 1], &c, 16);
                        }
                }
                return 0;                                       /* no match */
        }
        else    /* find option and return position */        
        {
                for (i = 1; i < argc; i++)
                {                
                        if (strcmp(argv[i], option) == 0)
                        {
                                t[i] = 1;
                                return i;       /* found! return position */
                        }
                }                                                          
                return 0;
        }
        return 0;
}

int i;
int numbo=0;
byte bGame;
reg z80reg;
byte *pbROM;
byte *pbRAM;
byte bShiftValue = 0;
byte bBitmap = 0;
byte bBitmapPrevious = 0;
DATAFILE *audio;

byte *RAM;
PALLETE invaders_pal; 
reg R;
FILE *in;
BITMAP *buffer;

int colf[10],colb[10]={16,32,48,64,80,96,112,128,144,160};
int main(int argc, char **argv)
{

	/* check command line for no options, process help */
        if (argc == 1)                                  /* show help */
                ShowHelp();
        if (FindOption("-?", 0, 0, 0, argc, argv) ||
            FindOption("-h", 0, 0, 0, argc, argv))
                ShowHelp();

        
	allegro_init(); 
	set_gfx_mode(GFX_MODEX, 256, 256, 0, 0);

        invaders_pal[0].r = invaders_pal[0].g = invaders_pal[0].b = 0;
        for (i = 1; i < 256; i++)
        {
                invaders_pal[i].r = invaders_pal[i].g =
invaders_pal[i].b = 0xf1;
        }
        set_palette(invaders_pal);

 	install_timer();
	install_keyboard();
        initialise_joystick();
	set_projection_viewport(0, 0, SCREEN_W, SCREEN_H);
	buffer = create_bitmap(SCREEN_W, SCREEN_H);
   	clear(buffer);	
			
	
	/* ok time to load the roms! */
          if (FindOption("invaders", 0, 0, 0, argc, argv))
              {
              RAM = malloc(0x10000);
	      in = fopen("roms/invaders/invaders.h", "rb"); //read in the invaders ROM in binary mode
	      fread(&RAM[0x0000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0000

			
			
		  in = fopen("roms/invaders/invaders.g", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0400

		  
		  
		  in = fopen("roms/invaders/invaders.f", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0800
	  
		  
		  in = fopen("roms/invaders/invaders.e", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00
              }

          else
          if (FindOption("earthinv", 0, 0, 0, argc, argv))
              {
              RAM = malloc(0x10000);
	      in = fopen("roms/earthinv/Earthinv.h", "rb"); //read in the invaders ROM in binary mode
	      fread(&RAM[0x0000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0000

			
			
		  in = fopen("roms/earthinv/Earthinv.g", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0400

		  
		  
		  in = fopen("roms/earthinv/Earthinv.f", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0800
	  
		  
		  in = fopen("roms/earthinv/Earthinv.e", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00
              }

          else
          if (FindOption("si_cv", 0, 0, 0, argc, argv))
              {
              RAM = malloc(0x10000);
	      in = fopen("roms/SI_CV/Cv17.bin", "rb"); //read in the invaders ROM in binary mode
	      fread(&RAM[0x0000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0000

			
			
		  in = fopen("roms/SI_CV/Cv18.bin", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0400

		  
		  
		  in = fopen("roms/SI_CV/Cv19.bin", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0800
	  
		  
		  in = fopen("roms/SI_CV/Cv20.bin", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00
              }

          else
              {
              RAM = malloc(0x10000);
	      in = fopen("roms/invaders/invaders.h", "rb"); //read in the invaders ROM in binary mode
	      fread(&RAM[0x0000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0000

			
			
		  in = fopen("roms/invaders/invaders.g", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0400

		  
		  
		  in = fopen("roms/invaders/invaders.f", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0800
	  
		  
		  in = fopen("roms/invaders/invaders.e", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00
              }

   	LOCK_VARIABLE(IFlag);
	LOCK_FUNCTION(Nmi);
	install_int(Nmi,8);

  clear(screen);                              //and clear the screen

      ResetZ80(&R);     //This resets the Z80 to its proper starting values
      Z80(R);           //Actually starts the emulation

  set_gfx_mode(GFX_TEXT,80,25,0,0); 

			printf("LASER 0.5\nBased On SinVader by Mike Green.\nZ80 Core by Marat Fayzullin\n");
                 

/* Lopantu's Arcade System Emulator Release 0.3 */


return 0;
}


void M_WRMEM(word A,byte V)
{
int x,y;

	if ( A < 0x2000)
	{

	return;
	}

	  RAM[A] = V;
	  
	if ( A > 0x23ff && A < 0x4000 ) // We must be trying to write to the screen!

	{
		i = (A - 0x2400 );
		x = i / 32;
		y = 8 * (i % 32);

        

                for (i = 0; i < 8; i++)
                {
                        putpixel(screen, x, 256-y, V & 1);
                        y++;
                        V >>= 1;
                }
		 
	}


}


byte M_RDMEM(word A)
{
//char buf[64];
//      sprintf(buf," Now reading RAM at %d", A);
// 
//	     textout_centre(buffer, font, buf, SCREEN_W / 2, 0, 10);
//		  blit(buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H); 
//		  getch();
	if ( A > 0x3f00 ) return(0);
//	if ( A < 0x3f00 )
//	return(RAM[A]);
//	if ( A < 0x2000 )
	return(RAM[A]);
//	else 
//	return(0);
	
}


/*** Input/Output values from/to ports: *******************/
/*** These are called on IN and OUT commands and should ***/
/*** supplied by machine-dependent part of the code.    ***/
/**********************************************************/
byte DoIn(byte Port)
{
	word wValue;
	byte bValue;
//	if (key[KEY_5]) colf++;
//	if (key[KEY_6]) colf--;
//	if (key[KEY_7]) colb++;
//	if (key[KEY_8]) colb--;
//	if (key[KEY_F3])
//	{
//		CPURunning=0;
//
//		ResetZ80(&R);
//	}
	switch(Port) {
		case 1:
			bValue=0x81;
			poll_joystick();
			if (joy_left)  bValue|=0x20; 
			if (joy_right) bValue|=0x40; 
			if (joy_b1) bValue|=0x10;
			if(key[KEY_ESC]) CPURunning=0;
			if(key[KEY_1]) bValue|=0x04;
			if(key[KEY_2]) bValue|=0x02;
			if(key[KEY_3]) bValue&=~0x01;
			if(key[KEY_LEFT]) bValue|=0x20;
			if(key[KEY_RIGHT]) bValue|=0x40;
			if(key[KEY_SPACE]) bValue|=0x10;
			return(bValue);
		case 2:
			bValue=0;
			if(key[KEY_T]) bValue=0x04;
			if(key[KEY_P]) bValue=0x08;
			if(bGame!=1) {
				if(key[KEY_LEFT]) bValue|=0x20;
				if(key[KEY_RIGHT]) bValue|=0x40;
				if(key[KEY_SPACE]) bValue|=0x10;
			}
			return(bValue);
		case 3:
			wValue=(bBitmap<<8)|bBitmapPrevious;
			wValue=wValue<<bShiftValue;
			bValue=(byte)(wValue>>8);
			return(bValue);
		default:
			return(0x00);
	}
}
void DoOut(byte Port,byte Value)
{
//	static byte bSound1 = 0;
//	static byte bSound2 = 0;

	switch(Port) {
		case 2:
			bShiftValue=Value;
			break;
//		case 3:
//			if(Value&0x01 &&  bSound1&0x01) play_sample(audio[0].dat,128,128,1000,1);
//			if(~Value&0x01 && bSound1&0x01) stop_sample(audio[0].dat);
//			if(Value&0x02 &&  bSound1&0x02) play_sample(audio[1].dat,128,128,1000,0);
//			if(~Value&0x02 && bSound1&0x02) stop_sample(audio[1].dat);
//			if(Value&0x04 &&  bSound1&0x04) play_sample(audio[2].dat,128,128,1000,0);
//			if(~Value&0x04 && bSound1&0x04) stop_sample(audio[2].dat);
//			if(Value&0x08 &&  bSound1&0x08) play_sample(audio[3].dat,100,128,1000,0);
//			if(~Value&0x08 && bSound1&0x08) stop_sample(audio[3].dat);
//			bSound1=Value;
//			break;
		case 4:
			bBitmapPrevious=bBitmap;
			bBitmap=Value;
			break;
//		case 5:
//			if(Value&0x01 &&  bSound2&0x01) play_sample(audio[4].dat,255,128,1000,0);
//			if(Value&0x02 &&  bSound2&0x02) play_sample(audio[5].dat,255,128,1000,0);
//			if(Value&0x04 &&  bSound2&0x04) play_sample(audio[6].dat,255,128,1000,0);
//			if(Value&0x08 &&  bSound2&0x08) play_sample(audio[7].dat,255,128,1000,0);
//			if(Value&0x10 &&  bSound2&0x10) play_sample(audio[8].dat,128,128,1000,0);
//			if(~Value&0x10 && bSound2&0x10) stop_sample(audio[8].dat);
//			bSound2=Value;
//			break;
	}
}


/**********************************************************/
/*** Emulate BIOS calls. This function is called on the ***/
/*** ED FE instruction to emulate disk/tape access, etc.***/
/*** Replace it with an empty macro for now patching.   ***/
/**********************************************************/
void Patch(reg *R)
{
}


word Interrupt()
{
//if (!IFlag) return(0x0010);
//return(0x0008);
  static byte bNMI = 0;
  if(bNMI++&0x01) return(0x0010);
  return(0x0008);
}

